<?  
if(!defined('VALID_CMS')) { die('ACCESS DENIED'); } 

function yanmail(){

	$inCore = cmsCore::getInstance(); 
	$inPage = cmsPage::getInstance(); 
	$inDB   = cmsDatabase::getInstance(); 
	$inUser = cmsUser::getInstance(); 
 
	$model = new cms_model_Yanmail(); 

	global $_LANG; 
	
	$cfg = $inCore->loadComponentConfig('yanmail');
	
	//Проверяем настройку конфигурации
	if (!$cfg['domain'] and !$cfg['token']) {
		cmsCore::addSessionMessage($_LANG['err_cfg'], 'info');
		$inCore->redirect('/');
		return;
	}
	
	
	$inPage->addPathway($pagetitle, '/yanmail');
	$inPage->setTitle($pagetitle);
	$inPage->setDescription($pagetitle);
	
	//присваиваем переменным необходимые значения
 	$pagetitle  = $inCore->getComponentTitle(); 
	$user_id    = $inUser->id;
	$domain     = $cfg['domain'];
	$token      = $cfg['token'];
	
	//Подключаем файл
	include_once 'curl.class.php';
	
    //Получаем текущее действие из URL страницы
    $do = $inCore->request('do', 'str', 'view');
 
 //даем доступ только авторизированным
 if($user_id){
   
    //получаем из базы информацию по $user_id
	$mail_id = $model->getBox($user_id);
 
 //если Do == add - добавление почтового ящика
    if ($do == 'add'){
	
		if($mail_id){
		//если запись в базе есть перенаправляем на страницу настройки
			$inCore->redirect('/yanmail/edit.html'); exit;
		}else{
			//Иначе устанавливаем заголовок страницы и получаем пристутствие send
			$inPage->setTitle($_LANG['add_title']);
			$is_send = $inCore->inRequest('send');
	 
				//Если send нет, то подключаем шаблон и выводим страницу добавления ящика
				if (!$is_send){
					cmsPage::initTemplate('components', 'com_yanmail_add')->display('com_yanmail_add.tpl'); 
				}
			
			//если send есть обрабытываем информацию
			if ($is_send){
				//получаем параметры
				$login      = $inCore->request('login', 'str');
				$pass	    = $inCore->request('pass', 'str');
	 
				//если не указан логин или пароль
				if (!$login || !$pass){
					//сохраняем текст ошибки в сессию
					cmsCore::addSessionMessage($_LANG['err_log_pass'], 'error');
					
					//и делаем редирект обратно на форму, завершая выполнение скрипта
					$inCore->redirectBack(); exit;
				}
				
				//Функция запроса к API Яндекса (в функцию передаем: токен, домен, логин и пароль)
				 function yAPIadd ($tok, $dom, $log, $ps) {
					$string = array();
					$curl = new curl();

					$headers = array('Host: pddimp.yandex.ru', 'PddToken: '.$tok);

					$curl -> set_httpheader($headers);
					$query = $curl -> post ("https://pddimp.yandex.ru/api2/admin/email/add","domain={$dom}&login={$log}&password={$ps}");
					$data = str_replace('}', "", strstr(str_replace('"','',$query ), "success:"));
					
					if (substr_count($data, ',') !=0) {
						$getString = explode(',', str_replace(' ', '', $data));
						foreach ($getString as $value) {
							list($key, $name) = explode(":", $value);
							$string[$key] = $name;
						}
					}elseif(substr_count($data, ',') == 0) {
							list($key, $name) = explode(":", str_replace(' ', '', $data));
							$string[$key] = $name;
							
					}
					
					//возвращаем массив
					return $string;
				}
				
				$arr = yAPIadd($token, $domain, $login, $pass);

				//Получаем uid
				$uid = $arr['uid'];
				
				//если состояние == ок
				if ($arr['success'] == 'ok') {
					//то добавляем в базу информацию
					$box_id = $model->addBox($user_id, $uid, $login);
					 //если ответ = true, то:
					 if ($box_id){
						//сохраняем текст успеха в сессию
						cmsCore::addSessionMessage("Почтовый ящик {$arr['login']} создан! uid={$uid}", 'success');
						//перенаправляем на страницу настройки
						$inCore->redirect('/yanmail/edit.html'); exit;
					}
					
					//Если по каким-то причинам сообщение не добавилось
					if (!$box_id){
						//сохраняем текст неудачи
						cmsCore::addSessionMessage($_LANG['error_add_db'], 'error');
					}
				
				//Если состояние == ошибке occupied
				}elseif($arr['error'] == "occupied\n"){
					//сохраняем текст неудачи
					cmsCore::addSessionMessage($_LANG['err_box_occupied'], 'error');
					
					 //Перенаправляем на страницу добавления
					 $inCore->redirect('/yanmail/add.html'); exit;
				//Если состояние == ошибке badpasswd
				}elseif($arr['error'] == "badpasswd\n"){
					cmsCore::addSessionMessage($_LANG['err_badpaswd'], 'error');
					
					 //Перенаправляем на страницу добавления
					 $inCore->redirect('/yanmail/add.html'); exit;
					 
				//Если состояние == passwd-tooshort
				}elseif($arr['error'] == "passwd-tooshort\n"){
					cmsCore::addSessionMessage($_LANG['err_passwd_short'], 'error');
					 //Перенаправляем на страницу добавления
					 $inCore->redirect('/yanmail/add.html'); exit;
				
				
				}elseif($arr['error'] == "badlogin\n"){
					cmsCore::addSessionMessage($_LANG['err_bad_login'], 'error');
					 //Перенаправляем на страницу добавления
					 $inCore->redirect('/yanmail/add.html'); exit;					
				}else{
				
				    //Если ошибка мной не учтена, но она есть, то выводим сообщение о ошибке
					cmsCore::addSessionMessage("{$_LANG['err_sent_data']}: {$arr['error']}", 'error');
					
					//Перенаправляем на страницу добавления
					 $inCore->redirect('/yanmail/add.html'); exit;
				}

	 
				//перенаправляем на страницу компонента
				$inCore->redirect('/yanmail'); exit;
	 
			}
		}	

    }
	
	//если Do == edit - настройка почтового ящика
    if ($do == 'edit'){
	
		//если запрос удачный
		if($mail_id){
			//Устанавливаем title страницы
			$inPage->setTitle($_LANG['edit_title']);
			
			//send
			$is_send = $inCore->inRequest('send');
			
			//Устанавливаем логин юзера
			$login      = $mail_id['login'];
			//Если кнопка "регистрация" еще не нажата
			if (!$is_send){
				//Устанавливаем переменным значения из базы
				$iname      = $mail_id['iname'];
				$fname      = $mail_id['fname'];
				$birth_date = $mail_id['birth_date'];
				
				//Устанавливаем дату
 				if ($birth_date != ""){
					list ($datemas['year'], $datemas['month'], $datemas['day']) = explode('-',$birth_date);
					$birth_date = '';
					$date = array(
						'day'=>array(),
						'month' => array(),
						'year' => array()
					);


					for($i=1; $i<=31; $i++) {

						if(strlen($i) > 1){
							$date['day']["$i"] = "$i";
						}else{
							$date['day']["0{$i}"] = "0{$i}";
						}
					}


					$mon = array (
						'01' => 'Январь',
						'02' => 'Февраль',
						'03' => 'Март',
						'04' => 'Апрель',
						'05' => 'Май',
						'06' => 'Июнь',
						'07' => 'Июль',
						'08' => 'Август',
						'09' => 'Сентябрь',
						'10' => 'Октябрь',
						'11' => 'Ноябрь',
						'12' => 'Декабрь'
					);


					for($i=1; $i<=12; $i++) {

						foreach ($mon as $key => $value) {

							if(strlen($i) < 10 and $i == $key){
								$date['month']["$key"] = "$value";
							}elseif($i == $key){
								$date['month']["0$key"] = "0$value";
							}
						}
					}

					for($i=1940; $i<=@date('Y'); $i++) {
							$date['year']["$i"] = "$i";
					}
					
					foreach ($datemas as $key=>$value) {
					$dates = "<select name='{$key}'>\n";
						foreach ($date[$key] as $promkey => $promValue){
							if($promkey == $value){
								$dates .= "<option selected ='selected' value='{$promkey}'>{$promValue}</option>\n";
							}else{
								$dates .= "<option value='{$promkey}'>{$promValue}</option>\n";
							}
						}
					$dates.= "</select>\n";
					$birth_date .= $dates;
					}
					
				}else{
					$birth_date = "<select name='day'>\n";
					for($i=1; $i<=31; $i++) {

						if(strlen($i) > 1){
							$birth_date.= "<option value='{$i}'>{$i}</option>\n";
						}else{
							$birth_date.= "<option value='0{$i}'>0{$i}</option>\n";
						}
					}
					$birth_date .= "</select>\n";
					
					$mon = array (
						'01' => 'Январь',
						'02' => 'Февраль',
						'03' => 'Март',
						'04' => 'Апрель',
						'05' => 'Май',
						'06' => 'Июнь',
						'07' => 'Июль',
						'08' => 'Август',
						'09' => 'Сентябрь',
						'10' => 'Октябрь',
						'11' => 'Ноябрь',
						'12' => 'Декабрь'
					);

					$birth_date .= "<select name='month'>\n";
					for($i=1; $i<=12; $i++) {

						foreach ($mon as $key => $value) {

							if(strlen($i) < 10 and $i == $key){
								$birth_date .= "<option value='{$key}'>{$value}</option>\n";
							}elseif($i == $key){
								$birth_date .= "<option value='0{$key}'>0{$value}</option>\n";
							}
						}
					}
					$birth_date .= "</select>\n";

					$birth_date .= "<select name='year'>\n";
					for($i=1940; $i<=@date('Y'); $i++) {
							$birth_date .= "<option value='{$i}'>{$i}</option>\n";
					}
					$birth_date .= "</select>\n";				
				}
				
				//Устанавливаем пол
				$sex       = $mail_id['sex'];
				if($sex == 0){
				$sex = <<<XXX
<select name='sex' style="width:250px">
	<option selected="selected" value="0">Не указано</option>
	<option value="1">Мужской</option>
	<option value="2">Женский</option>
</select>
XXX;
				}elseif($sex == 1){
				$sex = <<<XXX
<select name='sex' style="width:250px">
	<option value="0">Не указано</option>
	<option selected="selected" value="1">Мужской</option>
	<option value="2">Женский</option>
</select>
XXX;
				}elseif($sex == 2){
$sex = <<<XXX
<select name='sex' style="width:3250px">
	<option value="0">Не указано</option>
	<option value="1">Мужской</option>
	<option selected="selected" value="2">Женский</option>
</select>
XXX;
				}
				$hintq     = $mail_id['hintq'];
				
				
				//подключаем шаблон и выводим на поля
				cmsPage::initTemplate('components', 'com_yanmail_edit')->
				assign('login',$login) ->
				assign('iname',$iname) ->
				assign('fname',$fname) ->
				assign('birth_date',$birth_date) ->
				assign('sex',$sex) ->
				assign('hintq',$hintq) ->
				display('com_yanmail_edit.tpl');
			 
			}
			
			//Кнопка уже нажата
			if ($is_send){
				//Получаем все параметры
				$iname     = $inCore->request('iname', 'str');
				$fname	   = $inCore->request('fname', 'str');
				$password  = $inCore->request('password', 'str');
				$password2 = $inCore->request('password2', 'str');
				$day       = $inCore->request('day', 'str');
				$month     = $inCore->request('month', 'str');
				$year      = $inCore->request('year', 'str');
				$sex       = $inCore->request('sex', 'int');
				$hintq     = $inCore->request('hintq', 'str');
				$hinta     = $inCore->request('hinta', 'str');
				
				$pass = preg_match('/^[a-zA-Z0-9\!\@\#\$\%\^\&\*\(\)\_\-\+\:\;\,\.]{6,20}+$/', $password);
				 if ($password == ''){
					$pass = 1;
				 }				
					//Если пароли не совпадают, то:
					if($password != $password2){
						//Выводим сообшение об ошибке и перенаправляем на страницу настроек
						cmsCore::addSessionMessage($_LANG['err_passwd_no'], 'error');
						 $inCore->redirect('/yanmail/edit.html'); return;
					 }elseif(!$pass){
						//Если введены запрещенные символы, то выводим сообшение об ошибке и перенаправляем на страницу настроек
						cmsCore::addSessionMessage($_LANG['err_passwd_lang'], 'error');
						$inCore->redirect('/yanmail/edit.html'); return;					 
					 }
					 
					//Устанавливаем параметры запроса
					$birth_date = "{$year}-{$month}-{$day}";
					$param = array(
						'domain' => $domain,
						'login' => $login,
						'password' => $password,
						'iname' => $iname,
						'fname' => $fname,
						'birth_date' => $birth_date,
						'sex' => $sex,
						'hintq' => $hintq,
						'hinta' => $hinta
					);
					$paramQuery = '';
					$i = 0;
					$c = count($param);
					foreach ($param as $quekey => $quevalue){
						$i++;	
						if(strlen($quevalue) == 0){
							$c -=1;
							continue;
						}else{
							if($c > $i){
								$paramQuery .= "$quekey=$quevalue&";
							}else{
								$paramQuery .= "$quekey=$quevalue";
								}
						}
					}
					
					//Функция запроса к API яндекса (в функцию передаем: токен и строку запроса)
					function yAPIedit ($tok, $paramque) {
						$string = array();
						$curl = new curl();

						$headers = array('Host: pddimp.yandex.ru', "PddToken: {$tok}");

						$curl -> set_httpheader($headers);
						$query = $curl -> post ('https://pddimp.yandex.ru/api2/admin/email/edit',"$paramque");
						$data = str_replace('}', "", strstr(str_replace('"','',$query ), "success:"));
						
						if (substr_count($data, ',') !=0) {
							$getString = explode(',', str_replace(' ', '', $data));
							foreach ($getString as $value) {
								list($key, $name) = explode(":", $value);
								$promString[$key] = $name;
							}
						}elseif(substr_count($data, ',') == 0) {
								list($key, $name) = explode(":", str_replace(' ', '', $data));
								$promString[$key] = $name;
								
						}
						
						if ($promString['success'] == 'error'){
						//	return false;
							return $promString;
						}else{
							$stringpos = str_replace('"', '', substr(substr($query, strpos($query, '{"ui')), 1, strpos(substr($query, strpos($query, '{"ui')), '}, "s')-1));
							
							if (substr_count($stringpos, ',') !=0) {
								$get2String = explode(',', $stringpos);
								foreach ($get2String as $value) {
									list($key, $name) = explode(":", $value);
									
										$key = str_replace(' ', '', $key);
									
									if($key == 'fio' or $key == 'hintq'){
										$name = str_replace('', '', $name);
										$String[$key] = $name;
										
									}else{	
										$name = str_replace(' ', '', $name);
										$String[$key] = $name;
									}
								}
							}elseif(substr_count($stringpos, ',') == 0) {
									list($key, $name) = explode(":", $stringpos);
									$String[$key] = $name;
									
							}
							
							$String['success'] = $promString['success'];
							//возвращаем массив
							return $String;
							
						}
						
					}
					$editArr = yAPIedit($token, $paramQuery);
				  
				  //Если функция возвращает true:
				  if($editArr==true){
					
					//Если состояние == ok, то
					if($editArr['success'] == 'ok'){
						//Делаем запрос в базу
						$editB = $model->editBox($iname, $fname, $birth_date, $sex, $hintq, $user_id);
						
						//Если запрос true, то:
						if($editB == true){
							//Выводим сообщение об успехе
							cmsCore::addSessionMessage("Почтовый ящик {$editArr['login']} настроен! uid={$editArr['uid']}", 'success');
							
							//И перенаправляем на страницу настроек
							$inCore->redirect('/yanmail'); exit;
						
						//Если запрос == false, то:
						}elseif($editB == false){
							//Выводим сообщение об ошибке
							cmsCore::addSessionMessage($_LANG['error_edit_db'], 'error');
							//И перенаправляем на страницу настроек
							$inCore->redirect('/yanmail'); exit;
						}
						
					//Если состояние == error, то:
					}elseif($editArr['success'] == 'error'){
						//Выводим сообщение об ошибке
						cmsCore::addSessionMessage("Ошибка запроса к API: {$editArr['error']}", 'error');
						//И перенаправляем на страницу настроек
						$inCore->redirect('/yanmail'); exit;
					}
					
				  // Если функция вернула false, то:
				  }else{
					//Выводим сообщение о неизвестной ошибке (обратите внимание, возможно, в функции yAPIedit $promString['success'] == 'error')
					cmsCore::addSessionMessage($_LANG['err_sent_data'], 'error');
					//И перенаправляем на страницу настроек
					$inCore->redirect('/yanmail'); exit;
				  }
				

				
			}
		}
		
		//Если запрос не удачный, то:
		if(!$mail_id){
			//Выводим сообщение об ошибке
			cmsCore::addSessionMessage($_LANG['error_db'], 'error');
			$inCore->redirect('/yanmail/add.html'); exit;
			}
		}
		
////****************************************************************************************/////
////***************Если параметр "do" == view, то выводим страницу компонента***************/////
////****************************************************************************************/////
	
		if($do == 'view'){
			if($mail_id){
				$inPage->setTitle($_LANG['view_title']);
				$login      = $mail_id['login'];
				//Функция просмотра количества писем. В функцию передаем токен, домен и логин
				function yAPIview ($tok, $dom, $log) {
					$string = array();
					$curl = new curl();

					$headers = array('Host: pddimp.yandex.ru', 'PddToken: '.$tok);

					$curl -> set_httpheader($headers);
					$data = str_replace('"', '', $curl -> post ('https://pddimp.yandex.ru/api2/admin/email/counters', "domain={$dom}&login={$log}"));
					
					$getString = explode('{', str_replace('}', "", $data));
					unset($getString[0]);
					
					$get1String = explode(',', $getString[1]);
					
					foreach ($get1String as $value) {
						list($key, $name) = explode(":", str_replace(' ', '', $value));
						$get11String[$key] = $name;
					}
					unset($get11String['counters']);
					
					if($get11String['success'] == 'ok'){
					
					$get2String = explode(',', $getString[2]);
					
						foreach ($get2String as $value) {
							list($key, $name) = explode(":", str_replace(' ', '', $value));
							$string[$key] = $name;
						}
					
						return $string;
					
					}else{
						$error['success'] = $get11String['success'];
						$error['error'] = $get11String['error'];
						
						return $error;
					}
				}
				
				$view_arr = yAPIview ($token, $domain, $login);
				
				//При условии отсутствия ошибок определяем переменные
				if(!$view_arr['success']){
					$new = $view_arr['new'];
					$unread = $view_arr['unread'];
				}else{
				//Иначе выводим сообщение об ошибке
					if($view_arr['error']) {
						cmsCore::addSessionMessage($_LANG['view_err'].": {$view_arr['error']}", 'error'); exit;
					}
				}
				
				//Определяем переменные
				$iname      = $mail_id['iname'];
				$fname      = $mail_id['fname'];
				$birth_date = $mail_id['birth_date'];
				$hintq      = $mail_id['hintq'];
				$login 		.= "@".$domain;
				if($mail_id['sex'] == 0){
					$sex = "Не указан";
				}elseif($mail_id['sex'] == 1){
					$sex = "Мужской";
				}else{
					$sex = "Женский";
				}
				
				if($mail_id['enabled'] == 0){
					$enabled = "Заблокирован";
				}elseif($mail_id['enabled'] == 1){
					$enabled = "Работает";
				}
				$pubdate = $mail_id['pubdate'];
				
				
				//Выводим на шаблон
				cmsPage::initTemplate('components', 'com_yanmail_view')->
				assign('login', $login) ->
				assign('iname', $iname) ->
				assign('fname', $fname) ->
				assign('birth_date', $birth_date) ->
				assign('hintq', $hintq) ->
				assign('sex', $sex) ->
				assign('enabled', $enabled) ->
				assign('pubdate', $pubdate) ->
				assign('new', $new) ->
				assign('unread', $unread) ->
				assign('domain', $domain) ->
				display('com_yanmail_view.tpl'); 
			}
			
			//Если запрос неудачен, выводим сообщение с предложением завести ящик
			if(!$mail_id){
				cmsCore::addSessionMessage($_LANG['add_box'], 'info');
				$inCore->redirect('/yanmail/add.html'); exit;
			}
		}
		
	
	}else{
		//если юзер не авторизован переводим на страницу авторизации
		$inCore->redirect('/login'); exit;
	}	
}
 ?>